GNU bug report logs - #30394
'posix_spawn' glibc 2.26 race condition fires under qemu-binfmt

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Danny Milosavljevic <dannym@HIDDEN>; dated Thu, 8 Feb 2018 16:44:01 UTC; Maintainer for guix is bug-guix@HIDDEN.
Changed bug title to ''posix_spawn' glibc 2.26 race condition fires under qemu-binfmt' from 'ARM compilation via qemu binfmt - Assertion failure' Request was from ludo@HIDDEN (Ludovic Courtès) to control <at> debbugs.gnu.org. Full text available.

Message received at 30394 <at> debbugs.gnu.org:


Received: (at 30394) by debbugs.gnu.org; 16 Feb 2018 10:35:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 16 05:35:48 2018
Received: from localhost ([127.0.0.1]:45688 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1emdMq-0001H0-4U
	for submit <at> debbugs.gnu.org; Fri, 16 Feb 2018 05:35:48 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:33298)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1emdMn-0001Gr-Gx
 for 30394 <at> debbugs.gnu.org; Fri, 16 Feb 2018 05:35:46 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id C024E115E9;
 Fri, 16 Feb 2018 11:35:44 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 2v3CzkK3gZJ7; Fri, 16 Feb 2018 11:35:43 +0100 (CET)
Received: from ribbon (unknown [193.50.110.160])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 6C75C115BA;
 Fri, 16 Feb 2018 11:35:43 +0100 (CET)
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Danny Milosavljevic <dannym@HIDDEN>
Subject: Re: bug#30394: ARM compilation via qemu binfmt - Assertion failure
References: <87bmh4qrf5.fsf@HIDDEN>
 <87bmh3kbd9.fsf@HIDDEN>
 <87k1vqv23v.fsf@HIDDEN>
 <20180208174238.2abc85dc@HIDDEN>
Date: Fri, 16 Feb 2018 11:35:43 +0100
In-Reply-To: <20180208174238.2abc85dc@HIDDEN> (Danny Milosavljevic's
 message of "Thu, 8 Feb 2018 17:42:38 +0100")
Message-ID: <87vaexp6gw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 30394
Cc: guix-devel@HIDDEN, 30394 <at> debbugs.gnu.org, ng0@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Hello,

Danny Milosavljevic <dannym@HIDDEN> skribis:

> Unfortunately, there's a (pretty reproducible) problem with it.
>
> guix-master/guix $ ./pre-inst-env guix system disk-image --system=3Darmhf=
-linux -e "(@ (gnu system install) installation-os)"
> [... building grub-2.02 ...]
> phase `configure' succeeded after 821.8 seconds
> starting phase `patch-generated-file-shebangs'
> patch-makefile-SHELL: ./po/Makefile: changing `SHELL' from `/bin/sh' to `=
/gnu/st[...]
> phase `patch-generated-file-shebangs' succeeded after 14.6 seconds
> starting phase `build'
> bison -d -p grub_script_yy -b grub_script ./grub-core/script/parser.y
> flex -o grub_script.yy.c --header-file=3Dgrub_script.yy.h ./grub-core/scr=
ipt/yylex[...]
> bison: ../sysdeps/unix/sysv/linux/spawni.c:360: __spawnix: Assertion `ec =
>=3D 0' failed

[...]

> https://sourceware.org/bugzilla/show_bug.cgi?id=3D22273
> diff --git a/sysdeps/unix/sysv/linux/spawni.c b/sysdeps/unix/sysv/linux/s=
pawni.c
> index dea1650..f02ac19 100644
> --- a/sysdeps/unix/sysv/linux/spawni.c
> +++ b/sysdeps/unix/sysv/linux/spawni.c
> @@ -365,9 +365,15 @@ __spawnix (pid_t * pid, const char *file,
>    if (new_pid > 0)
>      {
>        ec =3D args.err;
> -      assert (ec >=3D 0);
>        if (ec !=3D 0)

Note that this is only a problem for code that uses the =E2=80=98posix_spaw=
n=E2=80=99
interface, such as Bison in the example above.

In practice that interface is rarely used, which is probably why I never
hit that assertion before.

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#30394; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 11 Feb 2018 09:57:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 11 04:57:54 2018
Received: from localhost ([127.0.0.1]:37626 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ekoOQ-00072J-LC
	for submit <at> debbugs.gnu.org; Sun, 11 Feb 2018 04:57:54 -0500
Received: from eggs.gnu.org ([208.118.235.92]:54368)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pjotr2017@HIDDEN>) id 1ekoOP-000728-UY
 for submit <at> debbugs.gnu.org; Sun, 11 Feb 2018 04:57:54 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <pjotr2017@HIDDEN>) id 1ekoOD-0003ap-Ry
 for submit <at> debbugs.gnu.org; Sun, 11 Feb 2018 04:57:48 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:35591)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <pjotr2017@HIDDEN>)
 id 1ekoNp-0003Ph-N8
 for submit <at> debbugs.gnu.org; Sun, 11 Feb 2018 04:57:41 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:45042)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <pjotr2017@HIDDEN>) id 1ekoNo-00080n-Ff
 for bug-guix@HIDDEN; Sun, 11 Feb 2018 04:57:17 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <pjotr2017@HIDDEN>) id 1ekoNl-0003MC-7U
 for bug-guix@HIDDEN; Sun, 11 Feb 2018 04:57:16 -0500
Received: from mail.thebird.nl ([95.154.246.10]:59637)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <pjotr2017@HIDDEN>)
 id 1ekoNl-0003LR-0x; Sun, 11 Feb 2018 04:57:13 -0500
Received: by mail.thebird.nl (Postfix, from userid 502)
 id 7CDD11248D7; Sun, 11 Feb 2018 10:53:32 +0100 (CET)
Date: Sun, 11 Feb 2018 10:53:32 +0100
From: Pjotr Prins <pjotr.public12@HIDDEN>
To: Chris Marusich <cmmarusich@HIDDEN>
Subject: Re: ARM compilation via qemu binfmt - Assertion failure
Message-ID: <20180211095332.GA18764@HIDDEN>
References: <87bmh4qrf5.fsf@HIDDEN>
 <87bmh3kbd9.fsf@HIDDEN>
 <87k1vqv23v.fsf@HIDDEN>
 <20180208174238.2abc85dc@HIDDEN>
 <87fu68o1dd.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87fu68o1dd.fsf@HIDDEN>
User-Agent: Mutt/1.5.21 (2010-09-15)
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [generic] [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
Cc: guix-devel@HIDDEN, Danny Milosavljevic <dannym@HIDDEN>,
 bug-guix@HIDDEN, ng0@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

On Sun, Feb 11, 2018 at 12:45:18AM +0100, Chris Marusich wrote:
> Danny Milosavljevic <dannym@HIDDEN> writes:
> 
> > This is only fixed in glibc 2.27 (not in core-updates).
> 
> Should we upgrade glibc in core-updates, then?  Or is it better to do it
> in the next core-updates cycle, to avoid still more unexpected breakage?

I think we should not update packages deep in the tree unless there is
a security patch. What we have now is well tested.

Pj.


-- 




Information forwarded to bug-guix@HIDDEN:
bug#30394; Package guix. Full text available.

Message received at 30394 <at> debbugs.gnu.org:


Received: (at 30394) by debbugs.gnu.org; 11 Feb 2018 01:07:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 10 20:07:31 2018
Received: from localhost ([127.0.0.1]:37442 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ekg79-0002tZ-9L
	for submit <at> debbugs.gnu.org; Sat, 10 Feb 2018 20:07:31 -0500
Received: from out2-smtp.messagingengine.com ([66.111.4.26]:32957)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo@HIDDEN>) id 1ekg77-0002tS-TB
 for 30394 <at> debbugs.gnu.org; Sat, 10 Feb 2018 20:07:30 -0500
Received: from compute4.internal (compute4.nyi.internal [10.202.2.44])
 by mailout.nyi.internal (Postfix) with ESMTP id CFC86209B1;
 Sat, 10 Feb 2018 20:07:29 -0500 (EST)
Received: from frontend2 ([10.202.2.161])
 by compute4.internal (MEProxy); Sat, 10 Feb 2018 20:07:29 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=famulari.name;
 h=cc:content-type:date:from:in-reply-to:message-id:mime-version
 :references:subject:to:x-me-sender:x-me-sender:x-sasl-enc; s=
 mesmtp; bh=GeORZkISfiNmWUkFICrzQpIE5HB6pEcY6L97u485rho=; b=NKdlK
 MYcBilsUkYHtjc8YfCg0FMQ8kXCmdWvOMAYkEqhrxYDYuwpUcqExQJaatwaAO8/Y
 DpKhIcb8bDN1IAhFtbzXamw7pnBo7pf/qyDCxCN72t6H8NMaSToNmw7epmbmK3Xn
 ndYtk/mv/VktKUfADsPFKFDw8FJ8oYYpXfaSSk=
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:references:subject:to:x-me-sender
 :x-me-sender:x-sasl-enc; s=fm2; bh=GeORZkISfiNmWUkFICrzQpIE5HB6p
 EcY6L97u485rho=; b=OQdPvudmS7+pq5NoN6PKBah5qeUy61iaflnZAZrclPEMI
 w9i3b1gOnVQb1hyGaN7u02xK9Bm66EkkEbJP6EuOFk3JLeBVC0oo3QzfY4FKDuqT
 x6u7ynNnezyYG7wcXma292ojDw7PGFNj7nQx0KGITEJBCl2SJ82E86wp9PR5ZO8f
 YVBTptBmTyn+6zBMnMdxs1+N8lWAdy8GQJH5m8MKF2s0JfUc9e1fa+Bba9+fVDhV
 KxmgtLPdpYrX/8H/N1Kp5v9NBRb/COc8Lm9dOfGDt1JO+qO2y8sGXi6wEOuW6g8o
 y1JWmdpLQ1jCYIkdcU9N2oy9rw1xG9/bXhA/1Ahdg==
X-ME-Sender: <xms:UZd_WmzmQ2A-dJvuy4f6aT_ijDN9Nr7zhbWylcpZjVuEM7hcFQoI-A>
Received: from localhost (c-76-124-202-137.hsd1.pa.comcast.net
 [76.124.202.137])
 by mail.messagingengine.com (Postfix) with ESMTPA id 88D8724406;
 Sat, 10 Feb 2018 20:07:29 -0500 (EST)
Date: Sat, 10 Feb 2018 20:07:28 -0500
From: Leo Famulari <leo@HIDDEN>
To: Chris Marusich <cmmarusich@HIDDEN>
Subject: Re: bug#30394: ARM compilation via qemu binfmt - Assertion failure
Message-ID: <20180211010728.GB28859@HIDDEN>
References: <87bmh4qrf5.fsf@HIDDEN>
 <87bmh3kbd9.fsf@HIDDEN>
 <87k1vqv23v.fsf@HIDDEN>
 <20180208174238.2abc85dc@HIDDEN>
 <87fu68o1dd.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature"; boundary="NMuMz9nt05w80d4+"
Content-Disposition: inline
In-Reply-To: <87fu68o1dd.fsf@HIDDEN>
User-Agent: Mutt/1.9.3 (2018-01-21)
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30394
Cc: guix-devel@HIDDEN, Danny Milosavljevic <dannym@HIDDEN>,
 30394 <at> debbugs.gnu.org, ng0@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)


--NMuMz9nt05w80d4+
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

On Sun, Feb 11, 2018 at 12:45:18AM +0100, Chris Marusich wrote:
> Danny Milosavljevic <dannym@HIDDEN> writes:
>=20
> > This is only fixed in glibc 2.27 (not in core-updates).
>=20
> Should we upgrade glibc in core-updates, then?  Or is it better to do it
> in the next core-updates cycle, to avoid still more unexpected breakage?

It's too late in this cycle. Upgrading glibc would require a full
rebuild and would introduce new failures.

--NMuMz9nt05w80d4+
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAABCAAdFiEEsFFZSPHn08G5gDigJkb6MLrKfwgFAlp/l1AACgkQJkb6MLrK
fwh4GxAAkLGGmGIDoiHr6i+qUFKLwrwbWIF7XV+OGX/8DX9j2Kin65WdJb6IduDz
ixXadA7UiOqdWouuaSq/cw/6zZuvKJZ8SXNNu3noGbseWlF7f2o+uwkhBUdFnUVZ
YipiQGmDDarMo+2ImTyFuYtLMEaHqiw9YK2rLhsTCj0VUk+X37zoOvM4DYJ2mpxX
KIdxxGjuxHtHgbOCJdgPn29Gh5xVvnwr+ZTCpLxBQa0f3z/SrU8v8/ibWKOyciaE
M09/PkQY6rYCWD3R01KFOnz98sQt3///BzSoRZnDs6c73M68ElTDxrAXiL3dOfj/
J/uuJd4WUJLHcuaVpsoaBEdWBs2KcQiwwcv+vRlIZ3bWOLxlcvrjb8gv49DirJkB
lZWqTYNEom8GQOdUq/zrOdLqC2NhRbZtTPZO/s7ceEY+itLwoyO4TDtjyTbBD2iq
NlE/zK8+E9NIl0pQevVgsOmcI5hpUeuS4OCv0+L3k5SD3uAFXw0MGa3Pljqwir/n
tq6FiqppBON1gPK8c21v/+gqeEhR33Z+4hcg24jH7+1TyAtz7kK0bUcvS2H+V5Bb
3/S+UcC+9LxnmOstIzsetfLe7dMUTQFCq1VvPX28tm+DT9ylcIc+wKhmokva0uYr
3UmsoPjpDDzZEhu5/gxnGUIzq7dC7SDlXGoT4GBwpwfsrmD5FqI=
=T/Z0
-----END PGP SIGNATURE-----

--NMuMz9nt05w80d4+--




Information forwarded to bug-guix@HIDDEN:
bug#30394; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Feb 2018 23:45:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 10 18:45:36 2018
Received: from localhost ([127.0.0.1]:37403 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ekepr-00014Y-O1
	for submit <at> debbugs.gnu.org; Sat, 10 Feb 2018 18:45:35 -0500
Received: from eggs.gnu.org ([208.118.235.92]:41580)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <cmmarusich@HIDDEN>) id 1ekepq-00014M-5s
 for submit <at> debbugs.gnu.org; Sat, 10 Feb 2018 18:45:34 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <cmmarusich@HIDDEN>) id 1ekepk-00045W-1K
 for submit <at> debbugs.gnu.org; Sat, 10 Feb 2018 18:45:28 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:52087)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <cmmarusich@HIDDEN>)
 id 1ekepj-00045I-UP
 for submit <at> debbugs.gnu.org; Sat, 10 Feb 2018 18:45:27 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:60754)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <cmmarusich@HIDDEN>) id 1ekepi-0006Hy-M8
 for bug-guix@HIDDEN; Sat, 10 Feb 2018 18:45:27 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <cmmarusich@HIDDEN>) id 1ekeph-000412-T6
 for bug-guix@HIDDEN; Sat, 10 Feb 2018 18:45:26 -0500
Received: from mail-pl0-x234.google.com ([2607:f8b0:400e:c01::234]:33631)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <cmmarusich@HIDDEN>)
 id 1ekeph-0003zE-M9; Sat, 10 Feb 2018 18:45:25 -0500
Received: by mail-pl0-x234.google.com with SMTP id t4so3205034plo.0;
 Sat, 10 Feb 2018 15:45:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=DPT9g448gWOHdwUFy9rMcW+ploXd8nRzauW/FGa3SfQ=;
 b=ktwxJrqk4Vndzph2PWW7LU6OMA1W7iH3tYnw+qGYa14zU9SUsEONK6mK+viptFCC+G
 AKbT4En8b2Lzdm6Uvm6OXz8wwmQQFTjoX3N9kv+NNaG8tuHML8fxBfQR0GfTXGuwIYWL
 JjYbK5Oena8YxRaX3znYHRwQqglgeT/lBiOdAvsCBl7AL677wMQEKIpND2Xp7LPcKumA
 EE08H+OEuD/k6D1StXFG8z17CrKJjLlMvPhTdL5oWZXVjw0nEEvTOUyUv8DHWtWHkL/f
 FycowE09SDgocen+7LkII3ER2tyub64GqLnqFmOPXddPzmsQfGwkzxcIccdDdBGG/HEP
 Kagw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=DPT9g448gWOHdwUFy9rMcW+ploXd8nRzauW/FGa3SfQ=;
 b=UqmUiQG5HrLfx/T1uhf5i8YDWH7NkM6rP6jpdhVXRNdEK9ovu8SGO2S1OYpQTUv1VA
 q9MbaUslqycQO6jp9bKIV4Hln4Ri6fAxSDQkUNBdRkHgeg60mWmeP576WOegqx7ifk3a
 GxZ6TWjRXfCWEnD013j5DLSXeNSESryJa+2Tze8ASQ7jSvN11IjpczSHtvCnYGxZLqO5
 wl09rDYyo7Z6fY/pX6j5O4Y5XAd1eJU9zUnLMWJxFG+tWjEJM/dpryfo+ALo23sENNBa
 ZDuky91mcceS597Kk7mJmeacbyO2kgQF5BUayALpZnQ/3tnduViKPEnHvocQaNX0VpP+
 ZMzw==
X-Gm-Message-State: APf1xPAKGTw3tvkhvDgFL/3kBoSODZlivv+G+Rn+Mrrrxa5M1OqtJEhE
 reBU4d7gITTuaqETDEE9EcZWqA==
X-Google-Smtp-Source: AH8x227uzYAk/k2DfZQvSkLoDXvsTa13ZhFXkZw/eBaqJhOVoKZC88nb0TcdrgHQzWiwmjSfGCO4Iw==
X-Received: by 2002:a17:902:7597:: with SMTP id
 j23-v6mr6718664pll.191.1518306324003; 
 Sat, 10 Feb 2018 15:45:24 -0800 (PST)
Received: from garuda.local ([2601:602:9d02:4725:6495:ba21:1ebe:620a])
 by smtp.gmail.com with ESMTPSA id 62sm16711234pfl.50.2018.02.10.15.45.22
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 10 Feb 2018 15:45:22 -0800 (PST)
From: Chris Marusich <cmmarusich@HIDDEN>
To: Danny Milosavljevic <dannym@HIDDEN>
Subject: Re: ARM compilation via qemu binfmt - Assertion failure
References: <87bmh4qrf5.fsf@HIDDEN>
 <87bmh3kbd9.fsf@HIDDEN>
 <87k1vqv23v.fsf@HIDDEN>
 <20180208174238.2abc85dc@HIDDEN>
Date: Sun, 11 Feb 2018 00:45:18 +0100
In-Reply-To: <20180208174238.2abc85dc@HIDDEN> (Danny Milosavljevic's
 message of "Thu, 8 Feb 2018 17:42:38 +0100")
Message-ID: <87fu68o1dd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
Cc: guix-devel@HIDDEN, bug-guix@HIDDEN, ng0@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Danny Milosavljevic <dannym@HIDDEN> writes:

> This is only fixed in glibc 2.27 (not in core-updates).

Should we upgrade glibc in core-updates, then?  Or is it better to do it
in the next core-updates cycle, to avoid still more unexpected breakage?

=2D-=20
Chris

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEEy/WXVcvn5+/vGD+x3UCaFdgiRp0FAlp/hA4ACgkQ3UCaFdgi
Rp1XhA/+L1qdclXARzM+Bgbjwhl7p/fHX2gFj0y/Ge0N3RZIeHuq03yzEggM7vm3
VnIDTMC3J6sEQAScH+oueGkZT6rQHds+qtyTsRZLO0gy3h9h8vgx/dIatiT7ZWb9
CtBrZbLJgK4o46qcY+0Z7THvFXegLb/4ua/qCiKn0lvW0BMKUuaYPzy/qRwwmeZP
l0Eg8PHgjfm4LMAKt1BSiV6kSi+2avExt0KUS9W5F1kZdTYJKyO5LWhYzZwtZtCh
2FeJMdPob754Ub/WEqEsFum1xRKyCG9JTymHCvCdvmQBrXIZ+SHI0NbHa0PxMO/f
1/LHf5fNuLf9aiGLAoDRTJtwjUKL7N2QC2TZvvV52q9Z/Q1nHaE49yWAPAhP4amW
zjqScH4yJ+4W7mKLmkOoxQpHgboZuemUh6i1Yfzek7utFDoGvhkQTaT8fjp31EMb
HB/4Q1SljaxsKK/rygGlmZ+BYr169V84GS6ennamDapz+sqTI9TO4nuXD5MpNR+b
bkcn1o0l4aYwnkf2zW/0mGXaD8YMfjVswk/zfcWLCdN4agPQ78iZOJGNqEpuoYqO
2ieou1nOLSn30l3TqogBAr8SJx/gAyYselSMvbR8rdvvYEMtlyH+3ASnEqQaFpFi
ZWJhMFY7AjgMgjemU5IkiTjsrpsSkih/n7yxYQHduantukTPd/w=
=Qp+k
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#30394; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Feb 2018 16:43:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 08 11:43:11 2018
Received: from localhost ([127.0.0.1]:34246 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ejpHz-0006l5-Bm
	for submit <at> debbugs.gnu.org; Thu, 08 Feb 2018 11:43:11 -0500
Received: from eggs.gnu.org ([208.118.235.92]:49443)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dannym@HIDDEN>) id 1ejpHx-0006ks-7m
 for submit <at> debbugs.gnu.org; Thu, 08 Feb 2018 11:43:09 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <dannym@HIDDEN>) id 1ejpHq-0007MP-PM
 for submit <at> debbugs.gnu.org; Thu, 08 Feb 2018 11:43:03 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:40037)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <dannym@HIDDEN>)
 id 1ejpHq-0007MG-Lw
 for submit <at> debbugs.gnu.org; Thu, 08 Feb 2018 11:43:02 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:40407)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <dannym@HIDDEN>) id 1ejpHp-0003KN-6u
 for bug-guix@HIDDEN; Thu, 08 Feb 2018 11:43:02 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <dannym@HIDDEN>) id 1ejpHl-0007Jw-9X
 for bug-guix@HIDDEN; Thu, 08 Feb 2018 11:43:01 -0500
Received: from dd26836.kasserver.com ([85.13.145.193]:47456)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <dannym@HIDDEN>)
 id 1ejpHl-0007J0-1R; Thu, 08 Feb 2018 11:42:57 -0500
Received: from localhost (77.118.210.201.wireless.dyn.drei.com
 [77.118.210.201])
 by dd26836.kasserver.com (Postfix) with ESMTPSA id ADDC43360375;
 Thu,  8 Feb 2018 17:42:53 +0100 (CET)
Date: Thu, 8 Feb 2018 17:42:38 +0100
From: Danny Milosavljevic <dannym@HIDDEN>
To: ng0@HIDDEN, guix-devel@HIDDEN, <bug-guix@HIDDEN>
Subject: ARM compilation via qemu binfmt - Assertion failure
Message-ID: <20180208174238.2abc85dc@HIDDEN>
In-Reply-To: <87k1vqv23v.fsf@HIDDEN>
References: <87bmh4qrf5.fsf@HIDDEN>
 <87bmh3kbd9.fsf@HIDDEN>
 <87k1vqv23v.fsf@HIDDEN>
X-Mailer: Claws Mail 3.16.0 (GTK+ 2.24.31; x86_64-unknown-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Hi ng0,

On Tue, 06 Feb 2018 10:33:56 +0000
ng0@HIDDEN wrote:

> recently I've read about slow but native compiling of ARM on qemu.

Unfortunately, there's a (pretty reproducible) problem with it.

guix-master/guix $ ./pre-inst-env guix system disk-image --system=armhf-linux -e "(@ (gnu system install) installation-os)"
[... building grub-2.02 ...]
phase `configure' succeeded after 821.8 seconds
starting phase `patch-generated-file-shebangs'
patch-makefile-SHELL: ./po/Makefile: changing `SHELL' from `/bin/sh' to `/gnu/st[...]
phase `patch-generated-file-shebangs' succeeded after 14.6 seconds
starting phase `build'
bison -d -p grub_script_yy -b grub_script ./grub-core/script/parser.y
flex -o grub_script.yy.c --header-file=grub_script.yy.h ./grub-core/script/yylex[...]
bison: ../sysdeps/unix/sysv/linux/spawni.c:360: __spawnix: Assertion `ec >= 0' failed

This is only fixed in glibc 2.27 (not in core-updates).

The fix is:

https://sourceware.org/bugzilla/show_bug.cgi?id=22273
diff --git a/sysdeps/unix/sysv/linux/spawni.c b/sysdeps/unix/sysv/linux/spawni.c
index dea1650..f02ac19 100644
--- a/sysdeps/unix/sysv/linux/spawni.c
+++ b/sysdeps/unix/sysv/linux/spawni.c
@@ -365,9 +365,15 @@ __spawnix (pid_t * pid, const char *file,
   if (new_pid > 0)
     {
       ec = args.err;
-      assert (ec >= 0);
       if (ec != 0)
-         __waitpid (new_pid, NULL, 0);
+       {
+         /* It handles the unlikely case where the auxiliary vfork process
+            is killed before calling _exit or execve.  */
+         int status;
+         __waitpid (new_pid, &status, 0);
+         if (WIFSIGNALED (status))
+           ec = 0;
+       }
     }
   else
     ec = -new_pid;




Acknowledgement sent to Danny Milosavljevic <dannym@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#30394; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 9 Mar 2018 12:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.